using System;
using System.IO;

namespace blue_dish_te
{
	public class DatLoader
	{
		private struct struct_files
		{
			public String fileName;
			public long Length;
			public long Position;
		}

		private const int HEADERLENGTH = 11;

		private FileStream fsin;
		private BinaryReader br;
		private struct_files[] files;

		private static bool TestFile(byte[] bytes)
		{
			byte[] origBytes = new byte[] {0x89, 0x44, 0x41, 0x54, 0x0D, 0x0A, 0x31, 0x2E, 0x30, 0x1A, 0x0A};
			if (bytes.Length != origBytes.Length) return false;
			for (int i = 0; i < origBytes.Length; i++)
				if (bytes[i] != origBytes[i])
					return false;
			return true;
		}

		public static DatLoader LoadDataFile(String filename)
		{
			DatLoader dl = new DatLoader();
			try
			{
				dl.fsin = new FileStream(filename, FileMode.Open, FileAccess.Read);
				dl.br = new BinaryReader(dl.fsin);

				if (!TestFile(dl.br.ReadBytes(HEADERLENGTH))) return null;

				dl.files = new struct_files[(uint) dl.br.ReadInt32()];
				for (int i = 0; i < dl.files.Length; i++)
				{
					byte name_length = dl.br.ReadByte();
					dl.files[i].fileName = new String(dl.br.ReadChars(name_length));
					dl.files[i].Length = (uint) dl.br.ReadInt32();
					dl.files[i].Position = dl.fsin.Position;
					dl.fsin.Seek(dl.files[i].Length, SeekOrigin.Current);
				}

				return dl;
			}
			catch(IOException ie)
			{
				Console.WriteLine(ie);
				return null;
			}
		}

		public Stream GetItem(String filename)
		{
			filename = filename.Replace("\\", "/");
			long position = -1;
			for (int i = 0; i < files.Length; i++)
				if (files[i].fileName.CompareTo(filename) == 0)
				{
					position = i;
					break;
				}
			if (position == -1) return null;

			MemoryStream mw = new MemoryStream((int) files[position].Length);
			fsin.Seek(files[position].Position, SeekOrigin.Begin);
			mw.Write(br.ReadBytes((int) files[position].Length), 0, (int) files[position].Length);
			mw.Seek(0, SeekOrigin.Begin);
			return mw;
		}
	}
}